<?php

# rubyEngine by Takekatsu HIRAMURA.
# v2.0 2007/07

//フォントディレクトリを指定
DEFINE("FONT_DIR","/usr/share/fonts/ja/TrueType/");

class rubyEngine{
 //大きさ
 function setSize($x,$y){
  $this->x=$x;
  $this->y=$y;
 }
 //文字列
 function setString($string){
  $this->string=$string;
 }
 //フォント
 function setFont($font){
  $this->font=FONT_DIR.$font;
 }
 //フォントの大きさ
 function setFontsize($fontsize){
  $this->fontsize=$fontsize;
 }
 //ルビの大きさ
 function setRubysize($rubysize){
  $this->rubysize=$rubysize;
 }
 //行間
 function setLinespacing($linespacing){
  $this->linespacing=$linespacing;
 }
 //オフセット
 function setOffset($offset){
  $this->offset=$offset;
 }
 //フォントの色
 function setFontcolor($fontcolor_r,$fontcolor_g,$fontcolor_b){
  $this->fontcolor_r=$fontcolor_r;
  $this->fontcolor_g=$fontcolor_g;
  $this->fontcolor_b=$fontcolor_b;
 }
 //背景
 function setBgcolor($bgcolor_r,$bgcolor_g,$bgcolor_b){
  $this->bgcolor_r=$bgcolor_r;
  $this->bgcolor_g=$bgcolor_g;
  $this->bgcolor_b=$bgcolor_b;
 }
 //文字コード
 function setCharset($charset){
  $this->charset=$charset;
 }
 //ファイルタイプ
 function setFiletype($filetype){
  $this->filetype=$filetype;
 }
 
 //画像の描画
 function display(){
  //HTTPヘッダを出力
  if($this->filetype=="gif"){ header("Content-type: image/gif"); }
  elseif($this->filetype=="jpeg"){ header("Content-type: image/jpeg"); }
  else{ header("Content-type: image/png"); }
  
  //枠を作る
  $im=imagecreatetruecolor($this->x,$this->y);
  $white=imagecolorallocate($im,$this->bgcolor_r,$this->bgcolor_g,$this->bgcolor_b);
  $black=imagecolorallocate($im,$this->fontcolor_r,$this->fontcolor_g,$this->fontcolor_b);
  imagefill($im, 0, 0, $white);
  
  //全角スペースを半角へ、行ごとに配列に格納
  $this->string=str_replace("　"," ",$this->string);
  $str_array=explode("\n",$this->string);
  
  //行の高さを定義
  $height=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
  
  //行ごとに処理
  foreach($str_array as $line){
   $width=10;
   while($line){
    //ルビ文字列にヒット
    if(preg_match("/^(\{ruby\()(.*?)(\|)(.*?)(\)\})/",$line,$str_block)){
     if($stack_str){
      imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
      $boxinfo=imagettfbbox($this->fontsize,0,$this->font,$stack_str);
      $width+=$boxinfo[2];
      $stack_str="";
     }
     //バウンディングボックスを生成、サイズ取得
     $boxinfo=imagettfbbox($this->fontsize,0,$this->font,$str_block[2]);
     $kanji_width=$boxinfo[2];
     $boxinfo=imagettfbbox($this->rubysize,0,$this->font,$str_block[4]);
     $ruby_width=$boxinfo[2];
     
     //改行
     if($width+$kanji_width>$this->x||$width+$ruby_width>$this->x){
      $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
      $width=10;
     }
     //漢字の横幅＞ひらがなの横幅のとき
     if($kanji_width>$ruby_width){
      if($width>10){ $width+=$this->fontsize*0.2; }
      imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,$str_block[2]);
      imagettftext($im,$this->rubysize,0,$width+($kanji_width/2)-($ruby_width/2),$height-($this->fontsize)-($this->offset),$black,$this->font,$str_block[4]);
      $width+=$kanji_width;
     }
     //漢字の横幅＜ひらがなの横幅のとき
     else{
      if($width>10){ $width+=$this->fontsize*0.2; }
      imagettftext($im,$this->rubysize,0,$width,$height-($this->fontsize)-($this->offset),$black,$this->font,$str_block[4]);
      imagettftext($im,$this->fontsize,0,$width+($ruby_width/2)-($kanji_width/2),$height,$black,$this->font,$str_block[2]);
      $width+=$ruby_width;
     }
     $line=preg_replace("/^(\{ruby\()(.*?)(\|)(.*?)(\)\})/","",$line);
    }
    //通常の文字列
    else{
     //バウンディングボックスを生成、サイズ取得
     $boxinfo=imagettfbbox($this->fontsize,0,$this->font,$stack_str.mb_substr($line,0,1,$this->charset));
     //横幅と新しいボックスが横幅をはみ出した場合
     if($width+$boxinfo[2]+10>($this->x)){
      //次の文字が禁則処理文字の場合
      if(preg_match("/^(、|。|」)/",mb_substr($line,0,1,$this->charset))){
       //スタックの直前の文字も禁則処理の場合→2文字を次の行へ送り、残りを描画
       if(preg_match("/^(、|。|」)/",mb_substr($stack_str,-1,1,$this->charset))){
       if($width>10){ $width+=$this->fontsize*0.2; }
       imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,mb_substr($stack_str,0,-2,$this->charset));
        $stack_str=mb_substr($stack_str,-2,2,$this->charset);
       }
       //スタックの直前の文字は禁則処理文字でない
       else{
        if($width>10){ $width+=$this->fontsize*0.2; }
        imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,mb_substr($stack_str,0,-1,$this->charset));
        $stack_str=mb_substr($stack_str,-1,1,$this->charset);
       }
       //改行
       $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
       $width=10;
      }
      //次の文字が禁則処理文字でない場合
      else{
       if($width>10){ $width+=$this->fontsize*0.2; }
       imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
       $stack_str="";
       $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
       $width=10;
      }
     }
     //スタックに格納
     $stack_str.=mb_substr($line,0,1,$this->charset);
     $line=mb_substr($line,1,mb_strlen($line,$this->charset),$this->charset);
    }
   }
   //あまったものを描画、スタックを開放、改行
   if($width>10){ $width+=$this->fontsize*0.2; }
   imagettftext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
   $stack_str="";
   $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
  }
  //描画、イメージ削除
  imagepng($im);
  imagedestroy($im);
 }
 
 //画像の描画(FreeType2を使用)
 function displayFt(){
  //HTTPヘッダを出力
  if($this->filetype=="gif"){ header("Content-type: image/gif"); }
  elseif($this->filetype=="jpeg"){ header("Content-type: image/jpeg"); }
  else{ header("Content-type: image/png"); }
  
  //枠を作る
  $im=imagecreatetruecolor($this->x,$this->y);
  $white=imagecolorallocate($im,$this->bgcolor_r,$this->bgcolor_g,$this->bgcolor_b);
  $black=imagecolorallocate($im,$this->fontcolor_r,$this->fontcolor_g,$this->fontcolor_b);
  imagefill($im, 0, 0, $white);
  
  //全角スペースを半角へ、行ごとに配列に格納
  $this->string=str_replace("　"," ",$this->string);
  $str_array=explode("\n",$this->string);
  
  //行の高さを定義
  $height=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
  
  //行ごとに処理
  foreach($str_array as $line){
   $width=10;
   while($line){
    //ルビ文字列にヒット
    if(preg_match("/^(\{ruby\()(.*?)(\|)(.*?)(\)\})/",$line,$str_block)){
     if($stack_str){
      imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
      $boxinfo=imageftbbox($this->fontsize,0,$this->font,$stack_str);
      $width+=$boxinfo[2];
      $stack_str="";
     }
     //バウンディングボックスを生成、サイズ取得
     $boxinfo=imageftbbox($this->fontsize,0,$this->font,$str_block[2]);
     $kanji_width=$boxinfo[2];
     $boxinfo=imageftbbox($this->rubysize,0,$this->font,$str_block[4]);
     $ruby_width=$boxinfo[2];
     
     //改行
     if($width+$kanji_width>$this->x||$width+$ruby_width>$this->x){
      $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
      $width=10;
     }
     //漢字の横幅＞ひらがなの横幅のとき
     if($kanji_width>$ruby_width){
      if($width>10){ $width+=$this->fontsize*0.2; }
      imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,$str_block[2]);
      imagefttext($im,$this->rubysize,0,$width+($kanji_width/2)-($ruby_width/2),$height-($this->fontsize)-($this->offset),$black,$this->font,$str_block[4]);
      $width+=$kanji_width;
     }
     //漢字の横幅＜ひらがなの横幅のとき
     else{
      if($width>10){ $width+=$this->fontsize*0.2; }
      imagefttext($im,$this->rubysize,0,$width,$height-($this->fontsize)-($this->offset),$black,$this->font,$str_block[4]);
      imagefttext($im,$this->fontsize,0,$width+($ruby_width/2)-($kanji_width/2),$height,$black,$this->font,$str_block[2]);
      $width+=$ruby_width;
     }
     $line=preg_replace("/^(\{ruby\()(.*?)(\|)(.*?)(\)\})/","",$line);
    }
    //通常の文字列
    else{
     //バウンディングボックスを生成、サイズ取得
     $boxinfo=imageftbbox($this->fontsize,0,$this->font,$stack_str.mb_substr($line,0,1,$this->charset));
     //横幅と新しいボックスが横幅をはみ出した場合
     if($width+$boxinfo[2]+10>($this->x)){
      //次の文字が禁則処理文字の場合
      if(preg_match("/^(、|。|」)/",mb_substr($line,0,1,$this->charset))){
       //スタックの直前の文字も禁則処理の場合→2文字を次の行へ送り、残りを描画
       if(preg_match("/^(、|。|」)/",mb_substr($stack_str,-1,1,$this->charset))){
        if($width>10){ $width+=$this->fontsize*0.2; }
        imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,mb_substr($stack_str,0,-2,$this->charset));
        $stack_str=mb_substr($stack_str,-2,2,$this->charset);
       }
       //スタックの直前の文字は禁則処理文字でない
       else{
        if($width>10){ $width+=$this->fontsize*0.2; }
        imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,mb_substr($stack_str,0,-1,$this->charset));
        $stack_str=mb_substr($stack_str,-1,1,$this->charset);
       }
       //改行
       $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
       $width=10;
      }
      //次の文字が禁則処理文字でない場合
      else{
       if($width>10){ $width+=$this->fontsize*0.2; }
       imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
       $stack_str="";
       $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
       $width=10;
      }
     }
     //スタックに格納
     $stack_str.=mb_substr($line,0,1,$this->charset);
     $line=mb_substr($line,1,mb_strlen($line,$this->charset),$this->charset);
    }
   }
   //あまったものを描画、スタックを開放、改行
   if($width>10){ $width+=$this->fontsize*0.2; }
   imagefttext($im,$this->fontsize,0,$width,$height,$black,$this->font,$stack_str);
   $stack_str="";
   $height+=($this->fontsize)+($this->rubysize)+($this->offset)+($this->linespacing);
  }
  
  //描画、イメージ削除
  //HTTPヘッダを出力
  if($this->filetype=="gif"){ imagegif($im); }
  elseif($this->filetype=="jpeg"){ imagejpeg($im); }
  else{ imagepng($im); }
  
  imagedestroy($im);
 }
 
}

?>
